import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class TextFieldTest implements ActionListener {
    private JFrame frame;
    private JButton button;
    private JTextField textfield;

    public static void main(String[] args) {
	TextFieldTest x = new TextFieldTest();
	x.drawStuff();
	x.doStuff();
    }
    
    void drawStuff() {
	frame = new JFrame("Test fr Threads");
	frame.setPreferredSize(new Dimension(450,110));

	// ein JTextField nach oben
	textfield = new JTextField("hallo");
	frame.add(textfield, BorderLayout.NORTH);
    
	// ein JButton nach unten
	button = new JButton("Auslesen");
	button.addActionListener(this);
	frame.add(button, BorderLayout.SOUTH);

	// Fenster zeichnen
	frame.pack();
	frame.setVisible(true);
    }

    void doStuff() {
	// Bitte nicht folgendermassen:
	System.err.println("Aus Haupt-Thread: " + textfield.getText());

	// sondern so:
	SwingUtilities.invokeLater(new Runnable() {
		public void run() {
		    System.err.println("Aus EDT: " + textfield.getText());
		}
	    });
		    
    }

    public void actionPerformed(ActionEvent e) {
	if( e.getSource() == button ) {
	    System.err.println(textfield.getText());
	}
    }
}
